/*--------------------------------------------------------------------*/
/*    i n s t a l l . c                                               */
/*                                                                    */
/*    Install/upgrade program for UUPC/extended                       */
/*                                                                    */
/*    Copyright (c) 1992 by Andrew H. Derbyshire                      */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*                          RCS Information                           */
/*--------------------------------------------------------------------*/

/*
 *    $Id: INSTALL.C 1.3 1993/04/11 00:33:54 ahd Exp $
 *
 *    Revision history:
 *    $Log: INSTALL.C $
 * Revision 1.3  1993/04/11  00:33:54  ahd
 * Global edits for year, TEXT, etc.
 *
 * Revision 1.2  1993/04/04  04:57:01  ahd
 * *** empty log message ***
 *
 * Revision 1.1  1992/11/15  04:29:22  ahd
 * Initial revision
 *
 */

static char rcsid[] =
      "$Id: INSTALL.C 1.3 1993/04/11 00:33:54 ahd Exp $";

/*--------------------------------------------------------------------*/
/*                      Standard C include files                      */
/*--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>

/*--------------------------------------------------------------------*/
/*                     UUPC/extended include files                    */
/*--------------------------------------------------------------------*/

#include "lib.h"
#include "timestmp.h"

/*--------------------------------------------------------------------*/
/*                          Local prototypes                          */
/*--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
/*    m a i n                                                         */
/*                                                                    */
/*    Main program                                                    */
/*--------------------------------------------------------------------*/

void main( int argc, char **argv )
{

/*--------------------------------------------------------------------*/
/*                       Announce our parentage                       */
/*--------------------------------------------------------------------*/

   banner( argv );

/*--------------------------------------------------------------------*/
/*         Determine if UUPC/extended may have been installed         */
/*--------------------------------------------------------------------*/

   if (getenv(UUPCSYSRC) == NULL )
      installed = FALSE;

   if (installed)
      update();
   else
      install();

} /* main */

/*--------------------------------------------------------------------*/
/*       i n s t a l l                                                */
/*                                                                    */
/*       Perform a basic install of UUPC/extended                     */
/*--------------------------------------------------------------------*/
