/*
 *  wsize - A program to show or change the size of a tkern window.
 *
 *  Copyright (C) 1994  Troy Rollo <troy@cbme.unsw.EDU.AU>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <sys/ioctl.h>
#include <ctype.h>
#include <stdlib.h>

int
main(	int	argc,
	char	**argv)
{
	struct	winsize	wsize;

	if (argc < 3)
	{
		ioctl(0, TIOCGWINSZ, &wsize);
		printf("%d Columns, %d Rows\n(%d x %d pixels)\n",
			wsize.ws_col, wsize.ws_row,
			wsize.ws_xpixel, wsize.ws_ypixel);
	}
	else
	{
		wsize.ws_col = atoi(argv[1]);
		wsize.ws_row = atoi(argv[2]);
		wsize.ws_xpixel = wsize.ws_ypixel = 0;
		ioctl(0, TIOCSWINSZ, &wsize);
	}
	return 0;
}
